/*    This file is part of Zmanim.

    Zmanim is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Zmanim is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zmanim; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "conf_file.h"
#include <cstdlib>
#include <qstringlist.h>
#include <qtextstream.h>
#include <qfile.h>

QStringList names(QValueList<location> const & names)
{
    QStringList retval;
    
    for (QValueList<location>::const_iterator i=names.begin();i!=names.end();++i)
    {
        retval+=(*i).name;
    }
    return retval;
}

QValueList<location> parseconfigfile()
{
    QValueList<location> retval;
    QString filename(std::getenv("HOME")); filename+="/.zmanrc";
    QFile tmp(filename);
    tmp.open(IO_ReadOnly);
    QTextStream infile(&tmp);
    QString line;
    while((line=infile.readLine())!=NULL)
    {
        line=line.simplifyWhiteSpace();
        if(line.length()>0 && !line.startsWith("#"))
        {
            QStringList linetokenized=QStringList::split(" ",line);
            location result;
            if (linetokenized[0]=="default") linetokenized.pop_front();
            result.name=linetokenized[0];
            result.latitude=linetokenized[1].toDouble();
            result.longitude=linetokenized[2].toDouble();
            result.tzname=linetokenized[3];
            retval.insert(retval.end(),result);
        }
    }
    
    return retval;
}

