/*    This file is part of Zmanim.

    Zmanim is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Zmanim is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zmanim; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include "sunfuncs.h"
#include "mydialog.h"
double const NETZ_AZIMUTH=90.83333333333333333,
SHKIAH_AZIMUTH=NETZ_AZIMUTH,
ALOT_AZIMUTH=90+16.1,
MESHEYAKIR_AZIMUTH=90+11,
TZAIT_AZIMUTH=90+8.5;
double const ph[]={3,4,6,6.5,9.5,10.75}; // loop through these right after updating netz



void mainform::init()
{
    locations=parseconfigfile();
    location_combo->insertStringList(names(locations));
    
    listView2->clear();
    listView2->setSorting(-1);//sets sorting based on insertion order, rather than a column
    listView2->setColumnText(0,"Event");
    listView2->addColumn("Time");
    
    display.resize(17);
    yesterday=new QListViewItem(listView2,"Yesterday");
    display.insert(0,yesterday);
    today=new QListViewItem(listView2,yesterday,"Today");
    display.insert(4,today);
    //these sort in the reverse of their insertion order
    display.insert(16,new QListViewItem(today,"Nightfall","0:00"));
    display.insert(15,new QListViewItem(today,"Sunset","0:00"));
    display.insert(14,new QListViewItem(today,"Candle Lighting","0:00"));
    display.insert(13,new QListViewItem(today,"Plag HaMincha","0:00"));
    display.insert(12,new QListViewItem(today,"Mincha Katanah","0:00"));
    display.insert(11,new QListViewItem(today,"Mincha Gedola","0:00"));
    display.insert(10,new QListViewItem(today,"Midday","0:00"));
    display.insert(9,new QListViewItem(today,"Latest Amidah","0:00"));
    display.insert(8,new QListViewItem(today,"Latest Sh'ma","0:00"));
    display.insert(7,new QListViewItem(today,"Sunrise","0:00"));
    display.insert(6,new QListViewItem(today,"Earliset Talit","0:00"));
    display.insert(5,new QListViewItem(today,"Daybreak","0:00"));
    display.insert(3,new QListViewItem(yesterday,"Nightfall","0:00"));
    display.insert(2,new QListViewItem(yesterday,"Sunset","0:00"));
    display.insert(1,new QListViewItem(yesterday,"Candle Lighting","0:00"));
    listView2->setOpen(today,true);
    listView2->setOpen(yesterday,true);
    
    //all the pointers to be updated in something_changed()
    //must be initialized before calling setDate (because setDate calls
    //something_changed().)
    date_edit->setDate(QDate::currentDate());    
}

void mainform::something_changed()
{
    location theloc=locations[location_combo->currentItem()];
    
    double const latitude=theloc.latitude, longitude=theloc.longitude;
    
    QString f= "h:mm ap"; //the date format
    
     {
        QDate thedate=date_edit->date().addDays(-1);
        yesterday->setText(0,QDate::shortDayName(thedate.dayOfWeek())+" "+thedate.toString(Qt::LocalDate));
	
	try{
	QTime ss=convert_to_tz(thedate,sunset(thedate,latitude,longitude,SHKIAH_AZIMUTH),theloc.tzname);
        display[1]->setText(1,ss.addSecs(-18.0*60.0).toString(f));        
        display[2]->setText(1,ss.toString(f));
	}catch(doesnthappen){
        display[1]->setText(1,"Could not compute");
        display[2]->setText(1,"Could not compute");
	}

	try{
        QTime tz=convert_to_tz(thedate,sunset(thedate,latitude,longitude,TZAIT_AZIMUTH),theloc.tzname);
        display[3]->setText(1,tz.toString(f));
	}catch(doesnthappen){display[3]->setText(1,"Could not compute");}
   }
   {
        QDate thedate=date_edit->date();
        today->setText(0,QDate::shortDayName(thedate.dayOfWeek())+" "+thedate.toString(Qt::LocalDate));

	try{
        QTime tz=convert_to_tz(thedate,sunset(thedate,latitude,longitude,TZAIT_AZIMUTH),theloc.tzname);
        display[16]->setText(1,tz.toString(f));
	}catch(doesnthappen){display[16]->setText(1,"Could not compute");}

	try{
        QTime al=convert_to_tz(thedate,sunrise(thedate,latitude,longitude,ALOT_AZIMUTH),theloc.tzname);
        display[5]->setText(1,al.toString(f));
	}catch(doesnthappen){display[5]->setText(1,"Could not compute");}

	try{
        QTime me=convert_to_tz(thedate,sunrise(thedate,latitude,longitude,MESHEYAKIR_AZIMUTH),theloc.tzname);
        display[6]->setText(1,me.toString(f));
	}catch(doesnthappen){display[6]->setText(1,"Could not compute");}

	try{
	   QTime sr=convert_to_tz(thedate,sunrise(thedate,latitude,longitude,NETZ_AZIMUTH),theloc.tzname);
	   QTime ss=convert_to_tz(thedate,sunset(thedate,latitude,longitude,SHKIAH_AZIMUTH),theloc.tzname);
	 
	   double prop_secs=sr.secsTo(ss)/12.0;
	   
	   display[7]->setText(1,sr.toString(f));
	   for (int x=8;x<14;++x)
	   {
	       display[x]->setText(1,sr.addSecs(ph[x-8]*prop_secs).toString(f));
	   }
	   display[14]->setText(1,ss.addSecs(-18.0*60.0).toString(f));        
	   display[15]->setText(1,ss.toString(f));
	}catch(doesnthappen){
	   for (int i=7;i<=15;++i)
	      display[i]->setText(1,"Could not compute");
	}
        
    }
}






void mainform::about_btn_clicked()
{
    MyDialog* w=new MyDialog();;
    w->exec();
    delete w;
}


void mainform::today_clicked()
{
    date_edit->setDate(QDate::currentDate());
}


void mainform::nextDay_clicked()
{
    date_edit->setDate(date_edit->date().addDays(1));
}


void mainform::prevDay_clicked()
{
    date_edit->setDate(date_edit->date().addDays(-1));
}
